'FFSubmenu=Skalieren
'FFName=Bildrand

'(c) Harald Maeckler, Dsseldorf 2009 - 2016

' ***********************************************************************
' Bildrand.vbs (Skript fr FixFoto)
'
' Funktion:	- Gewnschte Bildgre aus einem der installierten Belichterprofile aussuchen
'			- Rnder definieren in mm und Farbe auswhlen
'			- Zur Anpassung erfolgt eine automatische Rndervergrerung oder Verzerrung oder alternativ
'                wird der Ausschneidedialog mit berechneten Schnittwerten aufgerufen zum manuellen Ausschneiden
'			- Rnder werden hinzugefgt, ggf. mit gespiegeltem Inhalt gefllt, mit Unschrfe versehen
'			- Es wird skaliert nach Punktdichte gem gewhltem Belichterformat
'			- Die Punktdichte wird in die Bildinformation eingetragen
'
' Version 3.03 vom 29.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 3.02 vom 31.07.2012	- Spiegelfehler bei dpi = 1 behoben,
'									gleichzeitig sicher gsestellt, dass es keine berlappung mehr gibt
'								- Tooltippfehler bei Belichterauswahl beseitigt
' Version 3.01 vom 29.07.2012	- Bug beim Spiegeln mit Randvorgabe 0 beseitigt
' Version 3.00 vom 28.07.2012	- Kategorie "Skalieren" statt "Rahmen"
'								- Bildpfad umbenannt in Belichterverzeichnis
'								- Kurzbeschreibung im PDF-Format
'								- Tooltips eingefgt
'								- Versionsangabe und Updatefunktion
'								- Nummerierung bei gleichen Bildern
'								- Bildfilter fr BMP, JP2, JPG, JPEG, PNG, und TIF eingebaut
'								- fr DPI-Skalierung generelle Abfrage Ja, Immer, Nein, Nie
'								- Absturz bei vielen Bildern mit Tipp von Kuni verhindert
'								- Unterbrechen der Bearbeitungsschleife mit BACKSPACE statt Escape prfen
'								- Routine "Spiegeln" komplett neu
'								- Hinweis bei Auswahl "Bild auf der Arbeitsflche", dass nicht gespeichert wird
'								- Hinweis nach Start wo Bilder gespeichert werden
' Version 2.12 vom 24.07.2012	- optional Bilder in Unterordnern des Belichterverzeichnis speichern
' Version 2.11 vom 16.01.2010	- Skalierungsfehler behoben, die Zweite
' Version 2.10 vom 15.01.2010	- Skalierungsfehler behoben
' Version 2.09 vom 14.01.2010	- bei Anpassung durch Randvergrerung oder Verzerrung
'									Wahl zwischen Hoch- und Querformat
' Version 2.08 vom 25.11.2010	- Markierung im Dialog Ausschneiden angepasst an FF 3.02.25
' Version 2.07 vom 19.06.2010	- Aufruf ber das Skript 'Collage+' (ab Version 3.08) ermglicht
' Version 2.06 vom 15.06.2010	- bei Auswahl 'Bild auf der Arbeitsflche' wird das gezeigte Bild
'								  statt des abgespeicherten Bilds bearbeitet
' Version 2.05 vom 19.05.2010	- Kurzbeschreibung angepasst
' Version 2.04 vom 18.05.2010	- Bildauswahl zur Bearbeitung mehrerer Bilder in einem Durchgang
' Version 2.03 vom 13.05.2010	- wenn alle Rnder = 0 dann weder Spiegeln noch Unschrfe
' Version 2.02 vom 06.11.2009	- Infoanzeige abschaltbar
' Version 2.01 vom 11.09.2009	- Abfangen eines mglichen Fehlers bei der Randanpassung
' Version 2.00 vom 21.08.2009	- Auswahl Anpassung der Bildflche durch
'									Beschneiden, Randvergrerung, Verzerren
' Version 1.08 vom 20.08.2009	- Option "Anpassung durch Flchenvergrerung" hinzu
' Version 1.07 vom 11.08.2009	- nochmals "Bild im Rand Spiegeln" korrigiert
' Version 1.06 vom 10.08.2009	- Korektur des Randes bei "Bild im Rand Spiegeln"
' Version 1.05 vom 10.08.2009	- wahlweise Bild im Rand spiegeln
' Version 1.04 vom 08.08.2009	- wahlweise mit unscharfem Rand
' Version 1.03 vom 04.08.2009	- mit Flag "alle Rnder gleich"
' Version 1.02 vom 03.08.2009	- Kurzbeschreibung hinzugefgt
' Version 1.01 vom 03.08.2009	- auch fr hochformatige Bilder
' Version 1.00 vom 01.08.2009	- Betaversion

'** Start Kurzbeschreibung *******************************************
' Bildrand / Version 3.03
' ==============
' Das Skript dient dazu, Bilder so anzupassen, dass mit vorgebbaren Bildrndern in mm ein
' ausgewhltes Belichterformat erzeugt wird.
' Voraussetzung ist, dass mindestens ein Belichterprofil installiert ist und dieses mindestens
' ein Format enthlt. Nheres zum Thema Belichterprofile ist im Zubehrbereich des FixFoto-
' Forums unter Anleitungen zu finden. Dort ist ein Link auf die PDF-Datei "Belichter FAQ" von
' Kuni, die ich dringend empfehle zu lesen.
'
' Bildauswahl
' --------------
' Man kann sich entscheiden, ob das aktuelle Bild auf der Arbeitsflche oder alle Bilder bzw.
' nur die markierten Bilder der Computeransicht oder der aktiven Bilderliste bearbeitet werden 
' sollen. Die Bearbeitung von Fotos in einer Bilderliste ist allerdings erst ab FixFoto-Version
' 2.90 mglich. Ist eine ltere Version installiert, erfolgt ein entsprechender Hinweis.
'
' Ist 'Bild auf der Arbeitsflche gewhlt' wird dieses nach der Bearbeitung im bearbeiteten
' Zustand angezeigt und kann beliebig abgespeichert werden. Bei allen anderen Auswahlen
' werden die bearbeiteten Bilder automatisch gem den eingestellten 'Speicherparametern'
' (siehe unten) abgespeichert.
'
' Belichterauswahl
' --------------------
' Sind mehrere Belichterprofile installiert, kann man ber den Button "..." einen der Belichter
' aussuchen. Die im Profil enthaltenen Bildgren werden dann zur Auswahl angeboten.
'
' Rnder
' ---------
' Hier knnen die gewnschten Rnder in mm eingegeben und die Rahmenfarbe bestimmt werden.
' Wird ein Hkchen bei "alle gleich" gesetzt, werden alle Rnder wie der obere Rand behandelt.
'
' Statt dem Rahmen eine Farbe zu geben, kann auf Wunsch auch das Bild in den Rand gespiegelt 
' werden. Das kann man beispielsweise anwenden, wenn ein Bild auf Leinwand ausbelichtet wird
' und die Bildinformation den Keilrahmen bis zur Rckseite umschlieen soll.
' Ist einer der zu spiegelnden Rnder allerdings grer als die Bildbreite bzw. Bildhhe, ist
' eine Spiegelung nicht mglich. Die Rahmenerweiterung erfolgt dann in der gewhlten Farbe.
'
' Auerdem knnen die Rnder auf Wunsch mit einer Unschrfe versehen werden. Dabei kann 
' zwischen vier Strken gewhlt werden, nmlich 'wenig', 'mittel', 'stark' und 'extrem'. Da die
' Unschrfewirkung von der Punktdichte des Bildes abhngt, erfolgt pro 100 dpi ein Durchlauf der
' Unschrferoutine, was zu einer kleinen Verzgerung in der Abarbeitung fhren kann.
'
' Achtung:
' Es gibt Belichterprofile beispielsweise fr PC, Tablet, Smartphone oder TV, bei denen die
' Formate mit 1 dpi vorgegeben werden. Um hier eine sichtbare Randvorgabe zu erhalten, mssen
' die Randwerte sehr hoch sein, da sich bei 254 mm nur ein Rand von 1 px ergibt.
'
' Skalieren
' -----------
' Das gewhlte Belichterformat beinhaltet eine Sollvorgabe fr die Punktdichte in dpi. Um diese
' zu erreichen, muss das fertige Bild mit den Rndern skaliert werden. Je nach Vorlage und ge-
' whlten Ausschnitt ist es ggf. erforderlich, dass Bild hoch zu skalieren.
'
' Es kann gewhlt werden zwischen
' immer:		Es wird immer skaliert. Wenn allerdings hoch skaliert werden muss, erfolgt eine
'		Meldung und man kann sich fr skalieren 'Nein', 'Nie', 'Ja' oder 'Immer' entscheiden.
'		Bei Beantwortung mit 'Nie' oder 'Immer' erfolgt anschlieend keine Abfrage mehr.
' nur kleiner:	Es wird nur skaliert, wenn die Skalierung nach unten erfolgt.
' nie:		Es wird immer die sich fr das gewhlte Belichterformat ergebende Punktdichte 
'		bernommen.
'
' Wenn das Belichterformat die Punktdichte 1 dpi vorgibt, wird davon ausgegangen, dass die Ma-
' vorgabe px ist. In diesem Fall wird immer auf 1 dpi skaliert.
'
' Anpassung
' ------------
' Die Bildflche muss an das gewhlte Format mit den gewhlten Rndern angepasst werden. Dafr
' stehen zur Auswahl:
' - Beschneiden
'   Nach Start wird ein Ausschneidedialog aufgerufen, in dem proportional vernderbar ein Aus-
'   schnitt manuell gewhlt werden kann.
' - Randvergrerung
'   Es wird in der Vertikalen oder Horizontalen die notwendige Vergrerung des Randes berechnet
'   und automatisch durchgefhrt.
'   Ist 'auf Querformat' aktiviert, werden unabhngig vom vorliegenden Format die Rnder so ver-
'   grert, dass auf jeden Fall ein Querformat entsteht.
' - Verzerrung auf Hoch- oder Querformat
'   Das Bild wird automatisch so gestreckt bzw. gestaucht, dass die notwendige Bildgre erreicht wird.
'   Ist 'auf Querformat' aktiviert, wird das Bild so verzerrt, dass auf jeden Fall ein Querformat
'   entsteht.
'
' Die Anpassungsmanahmen erfolgen jeweils unter dem Aspekt der geringsten Bildvernderung, es sei
' denn ein Querforamt wird erzwungen.
'
' Speicherparameter
' ------------------------
' Hier knnen Bildqualitt und Kennung des Bildernamens definiert werden.
' Die Qualitt muss zwischen 65 und 100 liegen; bei 0 wird der FixFoto-Wert bernommen.
' Fr die Kennung kann gewhlt werden, ob diese als Prfix (Vorspann) oder Suffix (Nachspann)
' abgetrennt durch einen Unterstrich in den Bildnamen eingebaut werden soll.
'
' Beispiel:
' Bildname	DSC02463.jpg
' Kennung	BRD
' Kennung als Prfix	BRD_DSC02463.jpg
' Kennung als Suffix	DSC02463_BRD.jpg
'
' Ist die Option "Speichern im Belichterpfad" aktiviert, werden die Bilder statt im Originalverzeichnis
' in Unterordnern des Belichteverzeichnisses, das in den FF-Einstellungen unter Pfade definiert ist,
' abgelegt. Die Unterordner haben jeweils den Namen des gewhlten Formats und werden, wenn
' nicht schon vorhanden, automatisch angelegt.
'
' Existiert bereits eine Datei mit dem Namen des abzuspeichernden Bildes, wird dem Bildnamen in
' Klammern eine Zahl angehngt (z.B. DSC00609(1).JPG, DSC00609(2).JPG usw.), um berschreiben
' zu vermeiden.
'
' Ablauf
' ====
' Es werden nur Bilder mit der Dateierweiterung JPG, JPEG, JP2, TIF, BMP oder PNG verarbeitet,
' natrlich unabhngig von Gro- und Kleinschreibung.
'
' Mit Start wird berechnet, wie das Bild angepasst werden muss.
' Wenn die Anpassung durch "Beschneiden" aktiv ist, wird mit den berechneten Werten der Dialog 
' "Ausschneiden" gestartet. Dort kann dann proportional der gewnschte Ausschnitt gewhlt und 
' ausgeschnitten werden. Wird 'Schlieen' statt 'Ausfhren' gewhlt, wird das Bild nicht bear-
' beitet.
' Bei der "Randvergrerung" als Anpassung wird die Bildflche in der gewhlten Rahmenfarbe so ver-
' grert, dass sich mit den Rndern das gewnschte Format ergibt.
' Ist "Verzerrung" gewhlt, wird das Bild so gestreckt bzw. gestaucht, dass sich die richtige Bild-
' gre ergibt. 
' Danach werden im Hintergrund die eingestellten Rnder in der gewnschten Farbe hinzugefgt und
' nach der Skalierung der erzielte dpi-Wert in die Bildinformation eingetragen. Zum Schluss erfolgt
' bei aktivierter Infoanzeige eine Meldung ber die Anzahl der bearbeiteten Bilder, die Bildergre,
' die Randwerte und den Sollwert der Punktdichte.
'
' Bei Abarbeitung mehrerer Bilder kann mit der Taste 'BACKSPACE' der Vorgang unterbrochen werden. Es
' wird angezeigt, wieviel Bilder bereits bearbeitet sind und es wird gefragt, ob der Vorgang abgebrochen
' werden soll. Bei 'Ja' wird das Skript beendet, mit 'Nein' wird die Bearbeitung fortgesetzt.
'
' Update
' ---------
' Nach Bettigung der Taste 'Update' wird auf der Downloadseite des Skripts berprft, ob eine neuere
' Version vorliegt. Ist dies der Fall, wird angeboten die Downloadseite aufzurufen. Voraussetzung fr
' die Update-Prfung ist ein istallierter Internet-Explorer von Microsoft.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen angeboten,
' davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach werden nach-
' einander die Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle Zusatz-
' dateien gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "3.03"
const SkriptURL = "http://www.ffsf.de/resources/bildrand.143/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

const SkriptName = "Bildrand.vbs"			'Skriptname
const RegSchluessel = "FF_Bildrand"			'Registryschlssel

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8
Dim Anzeige

Dim SkriptKill,Antwort,TempFile								'Lschroutine

Dim Fertig,Bildbreite,Bildhoehe,flagInfo,Bild,img,AnzB,Abb	'Allgemein
Dim Auswahl,aktBl,allCV,selCV,allBL,selBL,Bilder			'Bildauswahl
Const BildFilter = ":BMP:JP2:JPG:PNG:TIF:JPEG:"
Dim Belichterprofil,Belichterformat,FormatIndex				'Belichterauswahl

Dim RandOben,RandUnten,RandLinks,RandRechts,flagRgleich		'Bildrandwerte
Dim Randlos
Dim Rpx_Oben,Rpx_Unten,Rpx_Links,Rpx_Rechts
Dim FarbFaktor,FarbWert										'Farbe
Dim SkalierFlag,SollDichte,Istdichte,DichteFaktor			'Dichte
Dim Dichteanpassung
Dim flagSpiegeln											'Spiegeln
Dim SpiegelFaktorH,SpiegelFaktorB
const Unschaerfe = "keine/wenig/mittel/stark/extrem"		'Unschrfe
const UnschaerfeStaerke = 5	'Promille der lngsten Seite
Dim flagUnschaerfe,UnschaerfeFaktor
const Skalierung = "immer skalieren/nur kleiner skalieren/niemals skalieren"
Dim AnpassKennung,SollHoeheN,SollBreiteN					'Anpassung
Dim SollHoehe_cm,SollBreite_cm,SollHoehe_px,SollBreite_px
Dim IstHoehe_px,IstBreite_px
Dim flagBeschnitt,Markierung								'Beschnitt
Dim flagRandV,flagRandVQF,ErweitVert,ErweitHor				'Randvergrerung
Dim flagVerzerr,flagVerzerrQF								'Verzerrung

Dim Qualitaet,SPP_Praefix,SPP_Suffix,Kennung				'Speicherparameter
Dim Ueberspeichern : Ueberspeichern = false

Dim isCollage												'wenn 1 dann Aufruf ber Collage+

Dim objFS,WshShell											'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Bilderverzeichnis
const Reg_BildV = "HKCU\Software\Joachim Koopmann Software\FixFoto\Options\ProviderPath"
Dim flag_SpBelPf,BelichterPfad

Abbruch = false : Fertig = false : Abb = false
'---------------------------------------------------------------------
call main
'---------------------------------------------------------------------
Sub main

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	Bildbreite = FF_GetImageWidth()	'Breite
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

'Bildhoehe = FF_GetImageHeight()

if Version_OK("3.02.25") then Markierung = 6 else Markierung = 2

'** Start Dialog Bildrand **
FF_AddDialog "Bildrand",208,216
FF_AddControl "Bildrand","Bildauswahl","GROUP",8,5,96,61
FF_AddControl "Bildrand","aktBl","BOOL",13,14,8,8
FF_SetControlStyle "Bildrand","aktBl",16384
FF_AddControl "Bildrand","Bild auf der Arbeitsflche","STATIC",25,14,73,10
FF_AddControl "Bildrand","allCV","BOOL",13,24,8,8
FF_SetControlStyle "Bildrand","allCV",16384
FF_AddControl "Bildrand","alle Bilder der Computeransicht","STATIC",25,24,78,10
FF_AddControl "Bildrand","selCV","BOOL",13,34,8,8
FF_SetControlStyle "Bildrand","selCV",16384
FF_AddControl "Bildrand","selektierte Bld. der Comp.-Ans.","STATIC",25,34,78,10
FF_AddControl "Bildrand","allBL","BOOL",13,44,8,8
FF_SetControlStyle "Bildrand","allBL",16384
FF_AddControl "Bildrand","alle Bilder der aktiven Bilderliste","STATIC",25,44,78,10
FF_AddControl "Bildrand","selBL","BOOL",13,54,8,8
FF_SetControlStyle "Bildrand","selBL",16384
FF_AddControl "Bildrand","selektierte Bld. der akt. Bilderl.","STATIC",25,54,78,10
FF_AddControl "Bildrand","Belichterauswahl","GROUP",108,5,92,50
FF_AddControl "Bildrand","Belichter","STATIC",115,12,33,10
FF_AddControl "Bildrand","BelichterName","SLEDIT",115,21,69,10
FF_SetControlStyle "Bildrand","BelichterName",2048
FF_AddControl "Bildrand","...","BUTTON",187,21,10,10
FF_AddControl "Bildrand","Bildgre","STATIC",115,32,38,10
FF_AddControl "Bildrand","BelichterWert","COMBO",115,41,82,10
FF_AddControl "Bildrand","Rnder [mm]","GROUP",8,71,96,98
FF_AddControl "Bildrand","flagRgleich","BOOL",65,76,8,8
FF_SetControlStyle "Bildrand","flagRgleich",16384
FF_AddControl "Bildrand","alle gleich","STATIC",77,75,25,10
FF_AddControl "Bildrand","RandOben","SLEDIT",38,82,16,10
FF_SetControlStyle "Bildrand","RandOben",8193
FF_AddControl "Bildrand","RandLinks","SLEDIT",13,88,16,10
FF_SetControlStyle "Bildrand","RandLinks",8193
FF_AddControl "Bildrand","RandRechts","SLEDIT",62,88,16,10
FF_SetControlStyle "Bildrand","RandRechts",8193
FF_AddControl "Bildrand","RandUnten","SLEDIT",38,95,16,10
FF_SetControlStyle "Bildrand","RandUnten",8193
FF_AddControl "Bildrand","Strich","STATIC",13,109,87,4
FF_SetControlStyle "Bildrand","Strich",7
FF_AddControl "Bildrand","Randfarbe","STATIC",13,118,27,10
FF_AddControl "Bildrand","Farbe","COLOR",45,117,49,10
FF_AddControl "Bildrand","alternativ","STATIC",13,128,33,10
FF_AddControl "Bildrand","flagSpiegeln","BOOL",13,140,8,8
FF_AddControl "Bildrand","Bild im Rand spiegeln","STATIC",25,139,67,10
FF_AddControl "Bildrand","Unschrfe","STATIC",14,154,27,10
FF_AddControl "Bildrand","flagUnschaerfe","COMBO",46,154,48,9
FF_AddControl "Bildrand","Skalieren auf den dpi-Wert","GROUP",108,58,92,31
FF_AddControl "Bildrand","der gewhlten Bildgre","STATIC",112,64,65,10
FF_AddControl "Bildrand","Skalierflag","COMBO",115,75,80,10
FF_AddControl "Bildrand","Anpassung","GROUP",108,92,92,60
FF_AddControl "Bildrand","flagBeschnitt","BOOL",115,101,8,8
FF_SetControlStyle "Bildrand","flagBeschnitt",16384
FF_AddControl "Bildrand","durch Beschneiden","STATIC",128,100,62,10
FF_AddControl "Bildrand","flagRandV","BOOL",115,111,8,8
FF_SetControlStyle "Bildrand","flagRandV",16384
FF_AddControl "Bildrand","durch Randvergrerung","STATIC",128,110,66,10
FF_AddControl "Bildrand","flagRandVQF","BOOL",130,120,8,8
FF_SetControlStyle "Bildrand","flagRandVQF",16384
FF_AddControl "Bildrand","auf Querformat","STATIC",144,119,48,10
FF_AddControl "Bildrand","flagVerzerr","BOOL",115,131,8,8
FF_SetControlStyle "Bildrand","flagVerzerr",16384
FF_AddControl "Bildrand","durch Verzerren","STATIC",128,130,52,10
FF_AddControl "Bildrand","flagVerzerrQF","BOOL",130,140,8,8
FF_SetControlStyle "Bildrand","flagVerzerrQF",16384
FF_AddControl "Bildrand","auf Querformat|","STATIC",144,139,48,10
FF_AddControl "Bildrand","Speicherparameter","BUTTON",110,155,88,11
FF_AddControl "Bildrand","Fortschritt","PROGRESS",8,174,192,6
FF_AddControl "Bildrand","?","BUTTON",14,192,11,11
FF_AddControl "Bildrand","Abbruch mit","STATIC",122,186,32,8
FF_SetControlStyle "Bildrand","Abbruch mit",1
FF_AddControl "Bildrand","flagInfo","BOOL",113,201,8,8
FF_AddControl "Bildrand","Infoanzeige","STATIC",122,200,32,10
FF_AddControl "Bildrand","Start","BUTTON",163,199,33,11
FF_AddControl "Bildrand","&d","BUTTON",4,4,1,1
FF_AddControl "Bildrand","BACKSPACE","BUTTON",154,186,35,8
FF_AddControl "Bildrand","|","STATIC",28,192,24,11
FF_SetControlStyle "Bildrand","|",1
FF_AddControl "Bildrand","Update","BUTTON",54,192,33,11
'** End Dialog Bildrand **

'wenn das mit Collage+ erstellte Bild bearbeitet werden soll
isCollage = FF_GetProfile(RegSchluessel,"isCollage")
if isCollage = "" then isCollage = 0
if isCollage = 1 then
	FF_AddControl "Bildrand","vonCollage","EDIT",12,13,90,51
	FF_SetControlStyle "Bildrand","vonCollage",2049
	FF_SetControl "Bildrand","vonCollage",vbNewLine & "Bearbeitung" & vbNewLine & _
									  vbNewLine & "des mit Collage+" & vbNewLine & _
									  vbNewLine & "erstellten Bildes"
end if
FF_WriteProfile RegSchluessel,"isCollage",0

call RegistryLesen
if Abbruch then exit sub

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Bildrand","flagUnschaerfe", "" &_
						 "Desto strker die Unschrfe gewhlt wird," & vbNewLine & _
						 "desto lnger dauert die Bearbeitung!"
	FF_SetControlTooltip "Bildrand","...","Aufruf der Belichterauswahl"
	FF_SetControlTooltip "Bildrand","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
						 "vorausgesetzt es ist ein PDF-Reader installiert." & vbNewLine & _
						 "Anderenfalls wird eine gekrzte Textversion angezeigt."
	FF_SetControlTooltip "Bildrand","Update", "" &_
						 "Prfung ob eine neue Version vorliegt."
end if

if flag_SpBelPf = 1 then
	call BelPfad_Lesen
	if Abbruch then
		msgbox "Das Flag 'Speichern im Belichterverzeichnis'" & vbNewLine & "wird zurck gesetzt!",vbInformation,"Hinweis"
		flag_SpBelPf = 0
		Abbruch = false
	end if
end if

FF_ActivateControl "Bildrand","&d"
FF_SetDialogTimer "Bildrand", 100

do

	if Version_OK("3.30.06") then
		FF_SetControlTooltip "Bildrand","BelichterName",Belichterprofil
		Belichterformat = FF_GetControl("Bildrand","BelichterWert")
		FF_SetControlTooltip "Bildrand","BelichterWert",Belichterformat
		if FF_GetControl ("Bildrand","flagBeschnitt") = "1" then
			FF_SetControlTooltip "Bildrand","BACKSPACE", "" &_
						 "Vorzeitiger Abbruch mglich durch" & vbNewLine & "'Ausfhren' des Ausschneidedialogs" & vbNewLine &_
						 "bei festgehaltener 'Backspace'-Taste."
		else
			FF_SetControlTooltip "Bildrand","BACKSPACE", "" &_
						 "Vorzeitiger Abbruch mglich durch" & vbNewLine & "Festhalten der 'Backspace'-Taste bis" & vbNewLine &_
						 "eine Rckmeldung erfolgt."
		end if
	end if

	Select Case FF_ShowDialog ("Bildrand")
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "TIMER"
		FF_SetControl "Bildrand" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Bildrand", 0
	Case "aktBl"		'Auswahl des aktuellen Bildes
		Auswahl = 4
		FF_SetControl "Bildrand","aktBl",1
		FF_SetControl "Bildrand","allCV",0
		FF_SetControl "Bildrand","selCV",0
		FF_SetControl "Bildrand","allBL",0
		FF_SetControl "Bildrand","selBL",0
		msgbox "Bei dieser Auswahl erfolgt keine" & vbNewLine & _
			   "automatische Speicherung des Bildes!",vbInformation,"Hinweis"
	Case "allCV"		'Auswahl alle in der Comp.-Ansicht
		Auswahl = 0
		FF_SetControl "Bildrand","aktBl",0
		FF_SetControl "Bildrand","allCV",1
		FF_SetControl "Bildrand","selCV",0
		FF_SetControl "Bildrand","allBL",0
		FF_SetControl "Bildrand","selBL",0
	Case "selCV"		'Auswahl markierte in der Comp.-Ansicht
		Auswahl = 1
		FF_SetControl "Bildrand","aktBl",0
		FF_SetControl "Bildrand","allCV",0
		FF_SetControl "Bildrand","selCV",1
		FF_SetControl "Bildrand","allBL",0
		FF_SetControl "Bildrand","selBL",0	
	Case "allBL"		'Auswahl alle in der aktuellen Bilderliste
		Auswahl = 2
		FF_SetControl "Bildrand","aktBl",0
		FF_SetControl "Bildrand","allCV",0
		FF_SetControl "Bildrand","selCV",0
		FF_SetControl "Bildrand","allBL",1
		FF_SetControl "Bildrand","selBL",0	
	Case "selBL"		'Auswahl markierte in der aktuellen Bilderliste
		Auswahl = 3
		FF_SetControl "Bildrand","aktBl",0
		FF_SetControl "Bildrand","allCV",0
		FF_SetControl "Bildrand","selCV",0
		FF_SetControl "Bildrand","allBL",0
		FF_SetControl "Bildrand","selBL",1
	Case "..."
		call ProfilAuswahl
		if not Abbruch then
			FF_SetControl "Bildrand","BelichterName",Belichterprofil
			FF_SetControl "Bildrand","BelichterWert",""
			call BelichterFormatEintrag
			if Abbruch then exit do
		end if
	Case "flagRgleich"
		if FF_GetControl ("Bildrand","flagRgleich") = "1" then
			FF_EnableControl "Bildrand","RandLinks",false
			FF_EnableControl "Bildrand","RandRechts",false
			FF_EnableControl "Bildrand","RandUnten",false
		else
			FF_EnableControl "Bildrand","RandLinks",true
			FF_EnableControl "Bildrand","RandRechts",true
			FF_EnableControl "Bildrand","RandUnten",true
		end if
	Case "BelichterWert"
		'Umlauf
	Case "flagBeschnitt"
		FF_SetControl "Bildrand","flagBeschnitt",1
		FF_SetControl "Bildrand","flagRandV",0
		FF_SetControl "Bildrand","flagRandVQF",0
		FF_SetControl "Bildrand","flagVerzerr",0
		FF_SetControl "Bildrand","flagVerzerrQF",0
	Case "flagRandV"
			FF_SetControl "Bildrand","flagRandV",1
			FF_SetControl "Bildrand","flagBeschnitt",0
			FF_SetControl "Bildrand","flagVerzerr",0
			FF_SetControl "Bildrand","flagVerzerrQF",0
	Case "flagRandVQF"
		if FF_GetControl("Bildrand","flagRandVQF") = 1 then
			FF_SetControl "Bildrand","flagBeschnitt",0
			FF_SetControl "Bildrand","flagRandV",1
			FF_SetControl "Bildrand","flagVerzerr",0
			FF_SetControl "Bildrand","flagVerzerrQF",0
		end if
	Case "flagVerzerr"
			FF_SetControl "Bildrand","flagVerzerr",1
			FF_SetControl "Bildrand","flagBeschnitt",0
			FF_SetControl "Bildrand","flagRandV",0
			FF_SetControl "Bildrand","flagRandVQF",0
	Case "flagVerzerrQF"
		if FF_GetControl("Bildrand","flagVerzerrQF") = 1 then
			FF_SetControl "Bildrand","flagBeschnitt",0
			FF_SetControl "Bildrand","flagRandV",0
			FF_SetControl "Bildrand","flagRandVQF",0
			FF_SetControl "Bildrand","flagVerzerr",1
		end if
	Case "Speicherparameter"
		call Parametereinstellung
	Case "?"
		'FF_SetControl "Bildrand","Fortschritt",65	'############## nur fr Screenshot
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\Bildrand\Bildrand.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?)." & vbNewLine & vbNewLine &_
				   "Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
			err.clear
			
			if not KBvorhanden then	call KurzbeschreibungLesen
			if KBvorhanden then
				call KurzbeschreibungAnzeigen
			else
				msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
			end if
			
		end if
		on error GoTo 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Start"
		Abbruch = false
		Randlos = false
		call WerteAuslesen
		call Kontrolle
		if not Abbruch then
			if Auswahl < 4 then
				if flag_SpBelPf = 1 then
					call BelPfad_Lesen
					if Abbruch then
						msgbox "Das Flag 'Speichern im Belichterverzeichnis'" & vbNewLine & "wird zurck gesetzt!",vbInformation,"Hinweis"
						flag_SpBelPf = 0
						Abbruch = false
					end if
				end if
				if flag_SpBelPf = 0 then
					Antwort = msgbox("Die bearbeiteten Bilder werden jeweils" & vbNewLine & _
									 "in ihrem Originalverzeichnis abgespeichert." & vbNewLine & vbNewLine & _
									 "Ist das in Ordnung?",vbQuestion + vbYesNo,"Speicherort")
				else
					Antwort = msgbox("Die bearbeiteten Bilder werden" & vbNewLine & _
									 "im Unterordner '" & Belichterformat & "'" & vbNewLine & _
									 "des Belichterverzeichnisses" & vbNewLine & _
									 BelichterPfad  & vbNewLine & _
									 "abgespeichert." & vbNewLine & vbNewLine & _
									 "Ist das in Ordnung?",vbQuestion + vbYesNo,"Speicherort")
				end if
				if Antwort = vbNo then Abbruch = true
			end if
			if not Abbruch then
				call Anpassung
				if flagInfo = 1 then Fertig = true
				exit do
			end if
		end if
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Bildrand")
if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen
if Fertig then
'Schlussmeldung
if Auswahl = 4 then img = 0
msgbox 	"Von " & img + 1 & " Bilder(n) wurde(n) " & AnzB & " bearbeitet!" & vbNewLine & vbNewLine & _
		"Bildabmessung mit Rndern:" & vbNewLine & vbNewline & _
		"Breite = " & IstBreite_px & " px = " & SollBreite_cm & " cm" & vbNewLine & _
		"Hhe =  " & IstHoehe_px & " px = " & SollHoehe_cm & " cm" & vbNewLine & vbNewLine & _
		"Rand oben   = " & RandOben & " mm" & vbNewline & _
		"Rand unten  = " & RandUnten & " mm" & vbNewline & _
		"Rand links     = " & RandLinks & " mm" & vbNewline & _
		"Rand rechts  = " & RandRechts & " mm" & vbNewline & vbNewLine & _
		"Punktdichte Soll = " & SollDichte & " dpi",vbInformation,"Info"
end if

End Sub
'---------------------------------------------------------------------
Sub BelPfad_Lesen
'Belichterverzeichnis auslesen und prfen

	on error resume next
	BelichterPfad = WshShell.RegRead (Reg_BildV)
	if err.number > 0 then
		msgbox "Der Wert ProviderPath ist im Registry-Schlssel" & _
			   "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options" & _
			   "nicht zu finden!",vbExclamation,"Meldung"
		Abbruch = true
		exit sub
	end if
	on error goto 0

	if len(BelichterPfad) = 0 then
		msgbox "Es ist kein Belichterverzeichnis in" & vbNewLine & _
			   "in den FF-Einstellungen unter Pfade zu finden!",vbExclamation,"Meldung"
		Abbruch = true
		exit sub
	end if

	if not objFS.FolderExists(BelichterPfad) then
		msgbox "Das in den FF-Einstellungen angegebene Belichterverzeichnis" & vbNewLine & _
		    BelichterPfad & vbNewLine & _
		   "existiert nicht!",vbExclamation,"Meldung"
		Abbruch = true
		exit sub
	end if

End Sub
'---------------------------------------------------------------------
Sub ProfilAuswahl
Dim Liste,Array,element

Liste = FF_PSGetList()
Array = split(Liste,vbNewLine)
if ubound(Array) = 0 then
	msgbox "Es ist nur ein Belichterprofil installiert!",vbInformation,"Hinweis"
	Abbruch = true
	exit sub
end if

'** Start Dialog Belichterprofil **
FF_AddDialog "Belichterprofil",108,42
FF_AddControl "Belichterprofil","BProfil","COMBO",8,8,90,10
FF_AddControl "Belichterprofil","bernehmen","BUTTON",50,26,35,11
'** End Dialog Belichterprofil **

for each element in Array
	FF_SetControl "Belichterprofil","BProfil",element
next

FF_SetControl "Belichterprofil","BProfil",Belichterprofil

do
	Select Case FF_ShowDialog ("Belichterprofil")
	Case "bernehmen"
		Belichterprofil = FF_GetControl ("Belichterprofil","BProfil")
		exit do
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Belichterprofil")

End Sub
'---------------------------------------------------------------------
Sub BelichterFormatEintrag
Dim FAnzahl,n

FAnzahl = FF_PSGetFormatCount(Belichterprofil)
if FAnzahl < 1 then
	msgbox 	"Im Belichterprofil " & Belichterprofil & " sind" & vbNewLine & _
			"keine Formate zu finden!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

for n = 0 to FAnzahl - 1
	FF_SetControl "Bildrand","BelichterWert",FF_PSGetFormatName(Belichterprofil,n)
	if Belichterformat = FF_PSGetFormatName(Belichterprofil,n) then
		FF_SetControl "Bildrand","BelichterWert",Belichterformat
		FormatIndex = n
	end if
next
End Sub
'---------------------------------------------------------------------
Sub WerteAuslesen
Dim Sk(2),n,Array

'Bildauswahl
if FF_GetControl ("Bildrand","allCV") = "1" then Auswahl = 0	'alle Dateien der Computeransicht
if FF_GetControl ("Bildrand","selCV") = "1" then Auswahl = 1	'markierte Dateien der Computeransich
if FF_GetControl ("Bildrand","allBL") = "1" then Auswahl = 2	'alle Dateien der aktuellen Bilderliste
if FF_GetControl ("Bildrand","selBL") = "1" then Auswahl = 3	'markierte Dateien der aktuellen Bilderliste
if FF_GetControl ("Bildrand","aktBl") = "1" then Auswahl = 4	'aktuelles Bild

if Auswahl < 4 then Bilder = FF_GetSelection(Auswahl)

'Belichterauswahl
Belichterprofil = FF_GetControl ("Bildrand","BelichterName")
Belichterformat = FF_GetControl ("Bildrand","BelichterWert")
for n = 0 to FF_PSGetFormatCount(Belichterprofil) - 1
	if Belichterformat = FF_PSGetFormatName(Belichterprofil,n) then
		FormatIndex = n
		exit for
	end if
next

'Rnder
RandOben = FF_GetControl ("Bildrand","RandOben")
flagRgleich = FF_GetControl ("Bildrand","flagRgleich")
if flagRgleich = 1 then
	RandUnten = RandOben
	RandLinks = RandOben
	RandRechts = RandOben
else
	RandUnten = FF_GetControl ("Bildrand","RandUnten")
	RandLinks = FF_GetControl ("Bildrand","RandLinks")
	RandRechts = FF_GetControl ("Bildrand","RandRechts")
end if
'if RandOben = 0 and RandUnten = 0 and RandLinks = 0 and RandRechts = 0 then Randlos = true

'Randfarbe
FarbFaktor = FF_GetControl ("Bildrand","Farbe")
FarbWert = split(FarbFaktor," ")

'Bildspiegelung
flagSpiegeln = FF_GetControl ("Bildrand","flagSpiegeln")

'Unschrfe
flagUnschaerfe = FF_GetControl ("Bildrand","flagUnschaerfe")
Array = split(Unschaerfe,"/")
for n = 0 to ubound(Array)
	if Array(n) = flagUnschaerfe then
		UnschaerfeFaktor = n * 8
		exit for
	end if
next

'Skalieren
Skalierflag = FF_GetControl ("Bildrand","Skalierflag")
Array = split(Skalierung,"/")
for n = 0 to ubound(Array)
	if Array(n) = Skalierflag then
		Skalierflag = n
		exit for
	end if
next

'Info
flagInfo = FF_GetControl ("Bildrand","flagInfo")

'Anpassung
flagBeschnitt = FF_GetControl ("Bildrand","flagBeschnitt")
if flagBeschnitt = 1 then AnpassKennung = "Beschnitt"

flagRandV = FF_GetControl ("Bildrand","flagRandV")
if flagRandV = 1 then AnpassKennung = "Randvergroesserung"
flagRandVQF = FF_GetControl ("Bildrand","flagRandVQF")
if flagRandVQF = 1 then AnpassKennung = "RandvergroesserungQF"

flagVerzerr = FF_GetControl ("Bildrand","flagVerzerr")
if flagVerzerr = 1 then AnpassKennung = "Verzerrung"
flagVerzerrQF = FF_GetControl ("Bildrand","flagVerzerrQF")
if flagVerzerrQF = 1 then AnpassKennung = "VerzerrungQF"

End Sub
'---------------------------------------------------------------------
Sub Kontrolle
Dim Text

'Versionstest
if Auswahl > 1 then		'Auswahl aktiver Bilderliste
	if not Version_OK("2.90.0") then
		msgbox "Um die Auswahl aktiver Bilderlisten nutzen zu knnen" & vbNewLine & _
			   "ist mindestens FixFoto-Version 2.90 erforderlich.",vbCritical,"Hinweis"
		Abbruch = true
		exit sub
	end if
end if

if Auswahl = 0 or Auswahl = 2 or (Auswahl = 4 and FF_GetImageWidth() < 1) then Text = "vorhanden!" else Text = "markiert!"
if len(Bilder) > 0 or (Auswahl = 4 and FF_GetImageWidth() > 1) then
else
	msgbox "Es ist kein Bild " & Text,vbExclamation,"Meldung"
	Abbruch = true
	exit sub	
end if

End Sub
'---------------------------------------------------------------------
Sub Anpassung
Dim ListeBilder,n,f
Dim SollHoeheV,SollBreiteV
Dim VB_Hoehe_Breite
Dim ZielHoehePx,ZielBreitePx
Dim SParameter,AntwortMD
Dim strExtension
const Format = "QF"

'Bilder in Array eintragen
ListeBilder = split(Bilder, vbNewLine)
img = ubound(ListeBilder)

n = 0 : AnzB = 0 : f = 0

do
	'vorzeitiger Abbruch?
	if FF_CheckKey() = 8 or Abb then 	'8 = Backspace
		Antwort = msgbox("Von " & img +1 & " Bildern wurden bisher " & n & _
					 " Bilder angepasst." & vbNewLine & vbNewLine & _
					 "Soll die weitere Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		Abb = false
		if Antwort = vbYes then exit sub
	end if
	
	if Auswahl < 4 then
		Bild = ListeBilder(n)
		FF_LoadImage Bild
		n = n + 1
		f = f + 1
		strExtension = ucase(objFS.GetExtensionName(Bild))		'Dateierweiterung fr Bildfilter
		FF_SetControl "Bildrand","Fortschritt",f/(img+1)*50		'Fortschritt
	else
		Bild = FF_GetImageName(-1)
	end if

if strExtension = "" or instr(BildFilter,":" & strExtension & ":") > 0 then	'Bildfilter

	ErweitVert = 0	: ErweitHor = 0
	Bildbreite = FF_GetImageWidth()
	Bildhoehe = FF_GetImageHeight()

	if flagRandVQF = 0 and flagVerzerrQF = 0 then
		if Bildbreite >= Bildhoehe then
			SollHoeheV  = FF_PSGetFormatHeight(Belichterprofil,FormatIndex)
			SollBreiteV = FF_PSGetFormatWidth(Belichterprofil,FormatIndex)
		else
			SollHoeheV  = FF_PSGetFormatWidth(Belichterprofil,FormatIndex)
			SollBreiteV = FF_PSGetFormatHeight(Belichterprofil,FormatIndex)
		end if
	else
		SollBreiteV = FF_PSGetFormatWidth(Belichterprofil,FormatIndex)		'### Querformat
		SollHoeheV  = FF_PSGetFormatHeight(Belichterprofil,FormatIndex)
	end if

	SollHoeheN  = SollHoeheV - RandOben / 10 - RandUnten / 10
	SollBreiteN = SollBreiteV - RandLinks / 10 - RandRechts / 10

	VB_Hoehe_Breite = SollHoeheN / SollBreiteN

	select case AnpassKennung
		case "Beschnitt"
			ZielHoehePx  = Bildhoehe
			ZielBreitePx = round(Bildhoehe / VB_Hoehe_Breite)
			if ZielBreitePx > Bildbreite then
				ZielBreitePx = Bildbreite
				ZielHoehePx = round(Bildbreite * VB_Hoehe_Breite)
			end if

			SParameter = "0,0," & ZielBreitePx & "," & ZielHoehePx & "," & Bildbreite & "," & Bildhoehe & "," & Markierung & ",1"
			FF_SetParam SParameter
			AntwortMD = FF_MultiDialog ("MultiCanvas",2)
			if AntwortMD < 0 then
				msgbox "Das Bild wurde nicht beschnitten!",vbInformation,"Hinweis"
				Abbruch = true
			end if
			if FF_CheckKey() = 8 or Abb then Abb = true
			
		case "Randvergroesserung","RandvergroesserungQF"
			ZielBreitePx = Bildhoehe / VB_Hoehe_Breite				'links/rechts erweitern
			if ZielBreitePx < Bildbreite then						'oben/unten erweitern
				ZielBreitePx = Bildbreite
				ZielHoehePx = Bildbreite * VB_Hoehe_Breite
				ErweitVert = (ZielHoehePx - Bildhoehe) / 2
			else													'links/rechts erweitern
				ErweitHor = (ZielBreitePx - Bildbreite) / 2
			end if
			if FF_CheckKey() = 8 or Abb then Abb = true
			
		case "Verzerrung","VerzerrungQF"
			ZielBreitePx = round(Bildhoehe / VB_Hoehe_Breite)
			ZielHoehePx = round(Bildbreite * VB_Hoehe_Breite)
			if abs(ZielBreitePx - Bildbreite) > abs(ZielHoehePx - Bildhoehe) then
				ZielBreitePx = Bildbreite
			else
				ZielHoehePx = Bildhoehe
			end if
			FF_HQScale ZielBreitePx,ZielHoehePx,false
			if FF_CheckKey() = 8 or Abb then Abb = true
			
	case else
	end select

	if Auswahl < 4 then
		f = f + 1
		FF_SetControl "Bildrand","Fortschritt",f/(img+1)*50
	end if

	if not Abbruch then

		FF_KillMask()	'zurck setzen des Stacks um Absturz durch Push und Pop zu vermeiden / ab Version 3.00
		AnzB = AnzB + 1
		call Rand
		if FF_CheckKey() = 8 or Abb then Abb = true
		if UnschaerfeFaktor > 0 then call UnschaerfeRoutine
		if FF_CheckKey() = 8 or Abb then Abb = true
		
		if not Abbruch then
		
			call Dichte
			if FF_CheckKey() = 8 or Abb then Abb = true
			
			if Auswahl = 4 then
				FF_Reload()	
			else
				call Speichern
				if FF_CheckKey() = 8 or Abb then Abb = true
			end if
			
		end if
	end if
	Abbruch = false

end if

	if n > img or Auswahl = 4 then exit do
loop

End Sub
'---------------------------------------------------------------------
Sub Rand
Dim IstHoehe,IstBreite

IstHoehe  =	FF_GetImageHeight()	+ 2* ErweitVert
IstBreite = FF_GetImageWidth()	+ 2* ErweitHor

Rpx_Oben   = RandOben / 10 / SollHoeheN * IstHoehe		+ ErweitVert
Rpx_Unten  = RandUnten / 10 / SollHoeheN * IstHoehe		+ ErweitVert
Rpx_Links  = RandLinks / 10 / SollBreiteN * IstBreite	+ ErweitHor
Rpx_Rechts = RandRechts / 10 / SollBreiteN * IstBreite	+ ErweitHor

'on error resume next
if flagSpiegeln = 1 then
	if Rpx_Links > FF_GetImageWidth or Rpx_Rechts > FF_GetImageWidth or Rpx_Oben > FF_GetImageHeight or Rpx_Unten > FF_GetImageHeight then
		Msgbox "Das Bild " & Bild & vbNewLine & _
			   "kann nicht gespiegelt werden weil einer der zu spiegelnden Rnder" & vbNewLine & _
			   "grer ist als die Bildbreite bzw. Bildhhe!",vbInformation,"Hinweis"
		FF_ExtendCanvas Rpx_Links,Rpx_Rechts,Rpx_Oben,Rpx_Unten,FarbWert(0),FarbWert(1),FarbWert(2)
	else
		FF_AdvanceImage Rpx_Links,Rpx_Rechts,Rpx_Oben,Rpx_Unten
	end if
else
	FF_ExtendCanvas Rpx_Links,Rpx_Rechts,Rpx_Oben,Rpx_Unten,FarbWert(0),FarbWert(1),FarbWert(2)
end if

if Err.Number > 0 then 
	msgbox 	"Bei der Randanpassung wurde die zulssige Bildgre berschritten" & vbNewLine & _
			"(ca. 10.000 Pixel fr Hhe und Breite) oder es besteht Speichermangel!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if
'on error goto 0

End Sub
'---------------------------------------------------------------------
Sub Dichte
Dim tempHoehe

SollDichte = FF_PSGetFormatDPI(Belichterprofil,FormatIndex)

if Bildbreite >= Bildhoehe then
	SollHoehe_cm  = FF_PSGetFormatHeight(Belichterprofil,FormatIndex)
	SollBreite_cm = FF_PSGetFormatWidth(Belichterprofil,FormatIndex)
else
	SollHoehe_cm  = FF_PSGetFormatWidth(Belichterprofil,FormatIndex)
	SollBreite_cm = FF_PSGetFormatHeight(Belichterprofil,FormatIndex)
end if
SollHoehe_px  = round(SollHoehe_cm * SollDichte / 2.54)
SollBreite_px =	round(SollBreite_cm * SollDichte / 2.54)

IstHoehe_px   =	FF_GetImageHeight()
IstBreite_px  = FF_GetImageWidth()
if IstBreite_px > IstHoehe_px then
	Istdichte = IstBreite_px / SollBreite_cm * 2.54
else
	Istdichte = IstHoehe_px / SollHoehe_cm * 2.54
end if

if (IstBreite_px >= IstHoehe_px) xor (SollBreite_px >= SollHoehe_px) then	'### bei erzwungenem Querformat
	tempHoehe = SollHoehe_px
	SollHoehe_px = SollBreite_px
	SollBreite_px = tempHoehe
	SollHoehe_cm = SollBreite_cm	'nur zur Berechnung der Istdichte nach dem Skalieren
end if

SpiegelFaktorH = SollHoehe_px / IstHoehe_px
SpiegelFaktorB = SollBreite_px / IstBreite_px

DichteFaktor =  SollDichte/Istdichte
ErweitVert = ErweitVert * DichteFaktor
ErweitHor  = ErweitHor  * DichteFaktor

if SollDichte = 1 then
	FF_HQScale SollBreite_px,SollHoehe_px,false
else
	select case  SkalierFlag	'Skalieren auf Solldichte
	case 0	'immer
		if Istdichte < SollDichte then
			if len(Dichteanpassung) = 0 then call Abfrage_Punktdichte
			
			Select Case Dichteanpassung
				Case "Nein"
					Dichteanpassung = ""
				Case "Nie"
				Case "Ja"
					FF_HQScale SollBreite_px,SollHoehe_px,false
					Dichteanpassung = ""
				Case "Immer"
					FF_HQScale SollBreite_px,SollHoehe_px,false
			End Select
		else
			FF_HQScale SollBreite_px,SollHoehe_px,false
		end if
	case 1	'nur kleiner
		if Istdichte >= SollDichte then
				FF_HQScale SollBreite_px,SollHoehe_px,false
		end if
	case 2	'nie
	case else
	end select
end if

IstHoehe_px   =	FF_GetImageHeight()
IstBreite_px  = FF_GetImageWidth()
Istdichte = round(IstHoehe_px / SollHoehe_cm * 2.54)

FF_SetDPI Istdichte

End Sub
'-------------------------------------------------------------------------
Sub UnschaerfeRoutine
Dim SToben,STunten,STlinks,STrechts,Zuschlag
Dim n,m

IstHoehe_px  =	FF_GetImageHeight()
IstBreite_px = FF_GetImageWidth()
if IstHoehe_px > IstBreite_px then
	Zuschlag = IstHoehe_px  / 1000 * UnschaerfeStaerke
else
	Zuschlag = IstBreite_px / 1000 * UnschaerfeStaerke
end if

SToben   = Rpx_Oben		+ Zuschlag
STunten  = Rpx_Unten	+ Zuschlag
STlinks  = Rpx_Links	+ Zuschlag
STrechts = Rpx_Rechts	+ Zuschlag

call FF_SetArea(0,0,0,0,false,0,0)
FF_AreaFillRect 0,0,STlinks,IstHoehe_px,255											'links
FF_AreaFillRect 0,0,IstBreite_px,SToben,255											'oben
FF_AreaFillRect 0,IstHoehe_px - STunten,IstBreite_px,IstHoehe_px,255				'rechts
FF_AreaFillRect IstBreite_px - STrechts,0,IstBreite_px,IstHoehe_px - STunten,255	'unten

m = round(IstDichte/100) * 2 : if m < 1 then m = 1
for n = 1 to m
	FF_Blur UnschaerfeFaktor
	if Auswahl = 4 then FF_SetControl "Bildrand","Fortschritt",n/m*100
next

End Sub
'--------------------------------------------------------------------------
Sub Speichern
Dim strPfad,strExtension,strName,Pos,n
Dim FormatPfad,f,fc

Pos = InStrRev(Bild,"\")
strPfad = left(Bild,Pos)
strName = objFS.GetBaseName(Bild)
strExtension = "." & objFS.GetExtensionName(Bild)

if SPP_Praefix = 1 then
	Bild = strPfad & Kennung & "_" & strName' & strExtension
elseif SPP_Suffix = 1 then
	Bild = strPfad & strName & "_" & Kennung' & strExtension
else
	Bild = strPfad & strName & strExtension
end if

if flag_SpBelPf = 1 then
	FormatPfad = objFS.BuildPath(Belichterpfad,Belichterformat)
	if not objFS.FolderExists(FormatPfad) then
		Set f = objFS.GetFolder(Belichterpfad)
		Set fc = f.SubFolders
		Set FormatPfad = fc.Add(Belichterformat)
	end if
	
	Bild = objFS.GetFileName(Bild)
	Bild = objFS.BuildPath(FormatPfad,Bild)
end if

'Bildname trennen in Pfad und Bildname ohne Extension
strPfad = objFS.GetParentFolderName(Bild)
strName = objFS.GetBaseName(Bild)
Bild = objFS.BuildPath(strPfad,strName)

'### vorhandene Bilder nummerieren mit (1), (2) usw.
if objFS.FileExists(Bild & strExtension) then
	n = 1
	do
		if not objFS.FileExists(Bild & "(" & n & ")" & strExtension) then exit do
		n = n + 1
	loop
	Bild = Bild & "(" & n & ")" & strExtension
else
	Bild = Bild & strExtension
end if

'Speichern
FF_SaveImage Bild,Qualitaet

End Sub
'--------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel
Dim Liste,Array,element,OK

'### Werte auslesen
'Auswahl
Auswahl = FF_GetProfile (RegSchluessel,"Auswahl")
if Auswahl = "" then Auswahl = 0

'Belichterprofil
OK = false
Belichterprofil = FF_GetProfile(RegSchluessel,"Belichterprofil")

Liste = FF_PSGetList()
if Liste = "" then
	msgbox "Keine Belichterprofile gefunden!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

Array = split(Liste,vbNewLine)
if Belichterprofil <> "" then
	for each element in Array
		if Belichterprofil = element then
			OK = true
			exit for
		end if
	next	
end if

if not OK then Belichterprofil = Array(0)

'Belichterformat
Belichterformat = FF_GetProfile(RegSchluessel,"Belichterformat")

'Rnder
flagRgleich = FF_GetProfile(RegSchluessel,"flagRgleich")
if flagRgleich = "" then flagRgleich = 0
RandOben = FF_GetProfile(RegSchluessel,"RandOben")
if RandOben = "" then RandOben = 0
RandUnten = FF_GetProfile(RegSchluessel,"RandUnten")
if RandUnten = "" then RandUnten = 0
RandLinks = FF_GetProfile(RegSchluessel,"RandLinks")
if RandLinks = "" then RandLinks = 0
RandRechts = FF_GetProfile(RegSchluessel,"RandRechts")
if RandRechts = "" then RandRechts = 0

'Randfarbe
FarbFaktor = FF_GetProfile(RegSchluessel,"FarbFaktor")
if FarbFaktor = "" then FarbFaktor = "255 255 255"

'Bildspiegelung
flagSpiegeln = FF_GetProfile(RegSchluessel,"flagSpiegeln")
if flagSpiegeln = "" then flagSpiegeln = 0

'Unschrfe
flagUnschaerfe = FF_GetProfile(RegSchluessel,"flagUnschaerfe")
if flagUnschaerfe = "" then flagUnschaerfe = "keine"

'Skalierung
SkalierFlag = FF_GetProfile(RegSchluessel,"SkalierFlag")
if SkalierFlag = "" then SkalierFlag = 0

'Anpassung
AnpassKennung = FF_GetProfile(RegSchluessel,"AnpassKennung")
if AnpassKennung = "" then AnpassKennung = "Beschnitt"

'Info
flagInfo = FF_GetProfile(RegSchluessel,"flagInfo")
if flagInfo = "" then flagInfo = 1

'Speicherparameter
Qualitaet = FF_GetProfile(RegSchluessel,"Qualitaet")
if Qualitaet = "" then Qualitaet = 0

SPP_Praefix = FF_GetProfile(RegSchluessel,"SPP_Praefix")
if SPP_Praefix = "" then SPP_Praefix = 0

SPP_Suffix = FF_GetProfile(RegSchluessel,"SPP_Suffix")
if SPP_Suffix = "" then SPP_Suffix = 1

Kennung = FF_GetProfile(RegSchluessel,"Kennung")
if Kennung = "" then Kennung = "BRD"

flag_SpBelPf = FF_GetProfile(RegSchluessel,"flag_SpBelPf")
if flag_SpBelPf = "" then flag_SpBelPf = 0

'### Werte eintragen
'Auswahl
select case Auswahl
	Case 0
		FF_SetControl "Bildrand","allCV",1
	Case 1
		FF_SetControl "Bildrand","selCV",1
	Case 2
		FF_SetControl "Bildrand","allBL",1
	Case 3
		FF_SetControl "Bildrand","selBL",1
	Case 4
		FF_SetControl "Bildrand","aktBl",1
Case else
End select

'Belichterprofil
FF_SetControl "Bildrand","BelichterName",Belichterprofil

'Belichterformat
call BelichterFormatEintrag
if Abbruch then exit sub

'Rnder
FF_SetControl "Bildrand","flagRgleich",flagRgleich
FF_SetControl "Bildrand","RandOben",RandOben
FF_SetControl "Bildrand","RandUnten",RandUnten
FF_SetControl "Bildrand","RandLinks",RandLinks
FF_SetControl "Bildrand","RandRechts",RandRechts

		if flagRgleich = "1" then
			FF_EnableControl "Bildrand","RandLinks",false
			FF_EnableControl "Bildrand","RandRechts",false
			FF_EnableControl "Bildrand","RandUnten",false
		else
			FF_EnableControl "Bildrand","RandLinks",true
			FF_EnableControl "Bildrand","RandRechts",true
			FF_EnableControl "Bildrand","RandUnten",true
		end if

'Randfarbe
FF_SetControl "Bildrand","Farbe",FarbFaktor

'Bildspiegelung
FF_SetControl "Bildrand","flagSpiegeln",flagSpiegeln

'Unschrfe
Array = split(Unschaerfe,"/")
for each element in Array
	FF_SetControl "Bildrand","flagUnschaerfe",element
next
FF_SetControl "Bildrand","flagUnschaerfe",flagUnschaerfe

'Skalierung
Array = split(Skalierung,"/")
for each element in Array
	FF_SetControl "Bildrand","Skalierflag",element
next
FF_SetControl "Bildrand","Skalierflag",Array(Skalierflag)

'Anpassung
select case AnpassKennung
	case "Beschnitt"
		FF_SetControl "Bildrand","flagBeschnitt",1
	case "Randvergroesserung"
		FF_SetControl "Bildrand","flagRandV",1
	case "RandvergroesserungQF"
		FF_SetControl "Bildrand","flagRandVQF",1
		FF_SetControl "Bildrand","flagRandV",1
	case "Verzerrung"
		FF_SetControl "Bildrand","flagVerzerr",1
	case "VerzerrungQF"
		FF_SetControl "Bildrand","flagVerzerrQF",1
		FF_SetControl "Bildrand","flagVerzerr",1
case else
end select

'Info
FF_SetControl "Bildrand","flagInfo",flagInfo

End Sub
'---------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'Werte auslesen
call WerteAuslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"Auswahl",Auswahl
FF_WriteProfile RegSchluessel,"Belichterprofil",Belichterprofil
FF_WriteProfile RegSchluessel,"Belichterformat",Belichterformat

FF_WriteProfile RegSchluessel,"flagRgleich",flagRgleich
FF_WriteProfile RegSchluessel,"RandOben",RandOben
FF_WriteProfile RegSchluessel,"RandUnten",RandUnten
FF_WriteProfile RegSchluessel,"RandLinks",RandLinks
FF_WriteProfile RegSchluessel,"RandRechts",RandRechts

FF_WriteProfile RegSchluessel,"FarbFaktor",FarbFaktor
FF_WriteProfile RegSchluessel,"flagSpiegeln",flagSpiegeln
FF_WriteProfile RegSchluessel,"flagUnschaerfe",flagUnschaerfe
FF_WriteProfile RegSchluessel,"SkalierFlag",SkalierFlag
FF_WriteProfile RegSchluessel,"AnpassKennung",AnpassKennung

FF_WriteProfile RegSchluessel,"flagInfo",flagInfo

End Sub
'---------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim Breite	: Breite = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"	'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'-------------------------------------------------------------------------
Function Version_OK(MinVersion)
Dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'-------------------------------------------------------------------------
Sub Parametereinstellung

'** Start Dialog Speicherparameter **
FF_AddDialog "Speicherparameter",81,91
FF_AddControl "Speicherparameter","Speicherqualitt","STATIC",6,5,40,10
FF_AddControl "Speicherparameter","Qualitaet","SLEDIT",56,5,16,10
FF_SetControlStyle "Speicherparameter","Qualitaet",8193
FF_AddControl "Speicherparameter","Bildname erweitern um","STATIC",6,18,60,10
FF_AddControl "Speicherparameter","SPP_Praefix","BOOL",8,29,8,8
FF_SetControlStyle "Speicherparameter","SPP_Praefix",16384
FF_AddControl "Speicherparameter","Prfix","STATIC",18,28,20,10
FF_AddControl "Speicherparameter","SPP_Suffix","BOOL",43,29,8,9
FF_SetControlStyle "Speicherparameter","SPP_Suffix",16384
FF_AddControl "Speicherparameter","Suffix","STATIC",55,28,20,10
FF_AddControl "Speicherparameter","Kennung","SLEDIT",6,40,66,10
FF_AddControl "Speicherparameter","flag_SpBelPf","BOOL",8,57,8,8
FF_SetControlStyle "Speicherparameter","flag_SpBelPf",16384
FF_AddControl "Speicherparameter","Speichern im","STATIC",19,53,50,8
FF_AddControl "Speicherparameter","Belichterverzeichnis","STATIC",19,61,50,8
FF_AddControl "Speicherparameter","bernehmen","BUTTON",39,75,33,11
'** End Dialog Speicherparameter **

if Version_OK("3.30.06") then
	FF_SetControlTooltip "Speicherparameter","Qualitaet", "" &_
						 "Qualitt der einzufgenden Bilder." & vbNewLine & "Bei 0 wird die FixFoto-Einstellung verwendet."
	FF_SetControlTooltip "Speicherparameter","Kennung", "" &_
						 "Kennung fr Prfix bzw. Suffix"
	FF_SetControlTooltip "Speicherparameter","flag_SpBelPf", "" &_
						 "Das Belichterverzeichnis wird in den" & vbNewLine & "FixFoto-Einstellungen unter Pfade definiert."
end if

FF_SetControl "Speicherparameter","Qualitaet",Qualitaet
FF_SetControl "Speicherparameter","SPP_Praefix",SPP_Praefix
FF_SetControl "Speicherparameter","SPP_Suffix",SPP_Suffix
FF_SetControl "Speicherparameter","Kennung",Kennung
FF_SetControl "Speicherparameter","flag_SpBelPf",flag_SpBelPf

do
	Select Case FF_ShowDialog ("Speicherparameter")
	Case "SPP_Praefix"
		if FF_GetControl("Speicherparameter","SPP_Praefix") = 1 then
			FF_SetControl"Speicherparameter","SPP_Suffix",0
		end if
	Case "SPP_Suffix"
		if FF_GetControl("Speicherparameter","SPP_Suffix") = 1 then
			FF_SetControl"Speicherparameter","SPP_Praefix",0
		end if
	Case "flag_SpBelPf"
		if FF_GetControl("Speicherparameter","flag_SpBelPf") = 1 then
			call BelPfad_Lesen
			if Abbruch then
				msgbox "Das Flag 'Speichern im Belichterverzeichnis'" & vbNewLine & "wird zurck gesetzt!",vbInformation,"Hinweis"
				flag_SpBelPf = 0
				FF_SetControl"Speicherparameter","flag_SpBelPf",0
				Abbruch = false
			end if
		end if
	Case "bernehmen"
		'Lesen
		Qualitaet = FF_GetControl("Speicherparameter","Qualitaet")
		if Qualitaet = "" then Qualitaet = 0		
		SPP_Praefix = FF_GetControl("Speicherparameter","SPP_Praefix")
		SPP_Suffix = FF_GetControl("Speicherparameter","SPP_Suffix")
		Kennung = FF_GetControl("Speicherparameter","Kennung")
		flag_SpBelPf = FF_GetControl("Speicherparameter","flag_SpBelPf")
		'Kontrolle
		if Qualitaet = 0 or Qualitaet > 64 and Qualitaet < 101 then
		else
			msgbox 	"Die Qualtitt muss 0 betragen (Std.-Einst. FixFoto)" & vbNewLine & _
					"oder zwischen 65 und 100 liegen!",vbInformation,"Hinweis"
			Abbruch = true
		end if
		
		if (SPP_Praefix = 1 or SPP_Suffix = 1) and Kennung = "" then
			msgbox	"Die Kennung muss mindestens aus einem Zeichen bestehen!",vbInformation,"Hinweis"
			Abbruch = true
		end if

		'Registry
		if not Abbruch then
			FF_WriteProfile RegSchluessel,"Qualitaet",Qualitaet
			FF_WriteProfile RegSchluessel,"SPP_Praefix",SPP_Praefix
			FF_WriteProfile RegSchluessel,"SPP_Suffix",SPP_Suffix
			FF_WriteProfile RegSchluessel,"Kennung",Kennung
			FF_WriteProfile RegSchluessel,"flag_SpBelPf",flag_SpBelPf
			exit do
		end if
		Abbruch = false
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop
FF_CloseDialog ("Speicherparameter")

End Sub
'-------------------------------------------------------------------------
Sub Abfrage_Punktdichte

'** Start Dialog Punktdichte **
FF_AddDialog "Punktdichte",126,78
FF_AddControl "Punktdichte","Von der geforderten Punkdichte ","STATIC",5,5,82,10
FF_AddControl "Punktdichte","Sdpi","SLEDIT",87,5,18,10
FF_SetControlStyle "Punktdichte","Sdpi",2049
FF_AddControl "Punktdichte","dpi","STATIC",109,5,10,10
FF_AddControl "Punktdichte","werden nur erreicht","STATIC",5,16,82,10
FF_AddControl "Punktdichte","Idpi","SLEDIT",87,16,18,10
FF_SetControlStyle "Punktdichte","Idpi",2049
FF_AddControl "Punktdichte","dpi|","STATIC",109,16,10,10
FF_AddControl "Punktdichte","Soll hoch skaliert werden?","STATIC",30,32,62,10
FF_AddControl "Punktdichte","Nein","BUTTON",11,47,33,11
FF_AddControl "Punktdichte","Nie","BUTTON",11,62,33,11
FF_AddControl "Punktdichte","Ja","BUTTON",73,46,33,12
FF_AddControl "Punktdichte","Immer","BUTTON",73,62,33,11
'** End Dialog Punktdichte **

FF_SetControl "Punktdichte","Sdpi",round(Solldichte)
FF_SetControl "Punktdichte","Idpi",round(Istdichte)

do
	Select Case FF_ShowDialog ("Punktdichte")
		Case "Nein"
			Dichteanpassung = "Nein"
			exit do
		Case "Nie"
			Dichteanpassung = "Nie"
			exit do
		Case "Ja"
			Dichteanpassung = "Ja"
			exit do
		Case "Immer"
			Dichteanpassung = "Immer"
			exit do
	End Select
loop

FF_CloseDialog ("Punktdichte")

End Sub
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
